---
title: llarp::apple::AppleVPNInterface

---

# llarp::apple::AppleVPNInterface





Inherits from [llarp::vpn::QueuedNetworkInterface](Classes/classllarp_1_1vpn_1_1QueuedNetworkInterface.md), std::enable_shared_from_this< AppleVPNInterface >, [llarp::vpn::NetworkInterface](Classes/classllarp_1_1vpn_1_1NetworkInterface.md), [llarp::vpn::I_Packet_IO](Classes/classllarp_1_1vpn_1_1I__Packet__IO.md)

## Public Types

|                | Name           |
| -------------- | -------------- |
| using std::function< void([AppleVPNInterface](Classes/classllarp_1_1apple_1_1AppleVPNInterface.md) &)> | **[on_readable_callback](Classes/classllarp_1_1apple_1_1AppleVPNInterface.md#using-on-readable-callback)**  |

## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[AppleVPNInterface](Classes/classllarp_1_1apple_1_1AppleVPNInterface.md#function-applevpninterface)**([Context](Classes/structllarp_1_1apple_1_1Context.md) & ctx, [layers::platform::PlatformLayer](Classes/classllarp_1_1layers_1_1platform_1_1PlatformLayer.md) & plat, packet_write_callback packet_writer, on_readable_callback on_readable) |
| virtual bool | **[WritePacket](Classes/classllarp_1_1apple_1_1AppleVPNInterface.md#function-writepacket)**([net::IPPacket](Classes/structllarp_1_1net_1_1IPPacket.md) pkt) override<br>write a packet to the interface returns false if we dropped it  |
| void | **[on_readable](Classes/classllarp_1_1apple_1_1AppleVPNInterface.md#function-on-readable)**()<br>continue reading packets.  |

## Additional inherited members

**Public Functions inherited from [llarp::vpn::QueuedNetworkInterface](Classes/classllarp_1_1vpn_1_1QueuedNetworkInterface.md)**

|                | Name           |
| -------------- | -------------- |
| | **[QueuedNetworkInterface](Classes/classllarp_1_1vpn_1_1QueuedNetworkInterface.md#function-queuednetworkinterface)**([InterfaceInfo](Classes/structllarp_1_1vpn_1_1InterfaceInfo.md) info, std::shared_ptr< [EventLoopWakeup](Classes/classllarp_1_1EventLoopWakeup.md) > send_wakeup, std::shared_ptr< [EventLoopWakeup](Classes/classllarp_1_1EventLoopWakeup.md) > recv_wakeup)<br>construct using recv_wakeup and send_wakeup that are informed when io happens.  |
| void | **[offer_read](Classes/classllarp_1_1vpn_1_1QueuedNetworkInterface.md#function-offer-read)**(std::vector< [net::IPPacket](Classes/structllarp_1_1net_1_1IPPacket.md) > pkt)<br>thread safe offer many ip packets to be read.  |
| void | **[offer_write](Classes/classllarp_1_1vpn_1_1QueuedNetworkInterface.md#function-offer-write)**(std::vector< [net::IPPacket](Classes/structllarp_1_1net_1_1IPPacket.md) > pkt)<br>thread safe offer an many ip packets to be written.  |
| virtual void | **[Stop](Classes/classllarp_1_1vpn_1_1QueuedNetworkInterface.md#function-stop)**() override<br>stop operation and tear down anything that [Start()](Classes/classllarp_1_1vpn_1_1I__Packet__IO.md#function-start) set up.  |
| virtual int | **[PollFD](Classes/classllarp_1_1vpn_1_1QueuedNetworkInterface.md#function-pollfd)**() const override<br>get pollable fd for reading  |

**Protected Attributes inherited from [llarp::vpn::QueuedNetworkInterface](Classes/classllarp_1_1vpn_1_1QueuedNetworkInterface.md)**

|                | Name           |
| -------------- | -------------- |
| [thread::Queue](Classes/classllarp_1_1thread_1_1Queue.md)< [net::IPPacket](Classes/structllarp_1_1net_1_1IPPacket.md) > | **[_send](Classes/classllarp_1_1vpn_1_1QueuedNetworkInterface.md#variable--send)**  |
| [thread::Queue](Classes/classllarp_1_1thread_1_1Queue.md)< [net::IPPacket](Classes/structllarp_1_1net_1_1IPPacket.md) > | **[_recv](Classes/classllarp_1_1vpn_1_1QueuedNetworkInterface.md#variable--recv)**  |
| std::shared_ptr< [EventLoopWakeup](Classes/classllarp_1_1EventLoopWakeup.md) > | **[_send_wakeup](Classes/classllarp_1_1vpn_1_1QueuedNetworkInterface.md#variable--send-wakeup)**  |
| std::shared_ptr< [EventLoopWakeup](Classes/classllarp_1_1EventLoopWakeup.md) > | **[_recv_wakeup](Classes/classllarp_1_1vpn_1_1QueuedNetworkInterface.md#variable--recv-wakeup)**  |

**Public Functions inherited from [llarp::vpn::NetworkInterface](Classes/classllarp_1_1vpn_1_1NetworkInterface.md)**

|                | Name           |
| -------------- | -------------- |
| | **[NetworkInterface](Classes/classllarp_1_1vpn_1_1NetworkInterface.md#function-networkinterface)**([InterfaceInfo](Classes/structllarp_1_1vpn_1_1InterfaceInfo.md) info) |
| | **[NetworkInterface](Classes/classllarp_1_1vpn_1_1NetworkInterface.md#function-networkinterface)**(const [NetworkInterface](Classes/classllarp_1_1vpn_1_1NetworkInterface.md) & ) =delete |
| | **[NetworkInterface](Classes/classllarp_1_1vpn_1_1NetworkInterface.md#function-networkinterface)**([NetworkInterface](Classes/classllarp_1_1vpn_1_1NetworkInterface.md) && ) =delete |
| const [InterfaceInfo](Classes/structllarp_1_1vpn_1_1InterfaceInfo.md) & | **[Info](Classes/classllarp_1_1vpn_1_1NetworkInterface.md#function-info)**() const |

**Protected Attributes inherited from [llarp::vpn::NetworkInterface](Classes/classllarp_1_1vpn_1_1NetworkInterface.md)**

|                | Name           |
| -------------- | -------------- |
| [InterfaceInfo](Classes/structllarp_1_1vpn_1_1InterfaceInfo.md) | **[m_Info](Classes/classllarp_1_1vpn_1_1NetworkInterface.md#variable-m-info)**  |

**Public Functions inherited from [llarp::vpn::I_Packet_IO](Classes/classllarp_1_1vpn_1_1I__Packet__IO.md)**

|                | Name           |
| -------------- | -------------- |
| virtual | **[~I_Packet_IO](Classes/classllarp_1_1vpn_1_1I__Packet__IO.md#function-~i-packet-io)**() =default |
| virtual void | **[Start](Classes/classllarp_1_1vpn_1_1I__Packet__IO.md#function-start)**()<br>start any platform specific operations before running  |
| virtual void | **[Stop](Classes/classllarp_1_1vpn_1_1I__Packet__IO.md#function-stop)**()<br>stop operation and tear down anything that [Start()](Classes/classllarp_1_1vpn_1_1I__Packet__IO.md#function-start) set up.  |
| virtual [net::IPPacket](Classes/structllarp_1_1net_1_1IPPacket.md) | **[ReadNextPacket](Classes/classllarp_1_1vpn_1_1I__Packet__IO.md#function-readnextpacket)**() =0<br>read next ip packet, return an empty packet if there are none ready.  |
| virtual int | **[PollFD](Classes/classllarp_1_1vpn_1_1I__Packet__IO.md#function-pollfd)**() const =0<br>get pollable fd for reading  |


## Public Types Documentation

### using on_readable_callback

```cpp
using llarp::apple::AppleVPNInterface::on_readable_callback =  std::function<void(AppleVPNInterface&)>;
```


## Public Functions Documentation

### function AppleVPNInterface

```cpp
explicit AppleVPNInterface(
    Context & ctx,
    layers::platform::PlatformLayer & plat,
    packet_write_callback packet_writer,
    on_readable_callback on_readable
)
```


### function WritePacket

```cpp
virtual bool WritePacket(
    net::IPPacket pkt
) override
```

write a packet to the interface returns false if we dropped it 

**Reimplements**: [llarp::vpn::I_Packet_IO::WritePacket](Classes/classllarp_1_1vpn_1_1I__Packet__IO.md#function-writepacket)


### function on_readable

```cpp
void on_readable()
```

continue reading packets. 

-------------------------------

Updated on 2023-03-25 at 01:02:43 +0000