---
title: llarp::layers::platform::OSTraffic_IO_Base

---

# llarp::layers::platform::OSTraffic_IO_Base





Inherited by [llarp::apple::AppleOSTraffic_IO](Classes/classllarp_1_1apple_1_1AppleOSTraffic__IO.md)

## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[OSTraffic_IO_Base](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO__Base.md#function-ostraffic-io-base)**(const EventLoop_ptr & ) |
| virtual | **[~OSTraffic_IO_Base](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO__Base.md#function-~ostraffic-io-base)**() =default |
| constexpr const [PlatformAddr](Classes/structllarp_1_1layers_1_1platform_1_1PlatformAddr.md) & | **[our_platform_addr](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO__Base.md#function-our-platform-addr)**() const<br>get the platform address of the underlying device managed.  |
| void | **[attach](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO__Base.md#function-attach)**(std::shared_ptr< [vpn::NetworkInterface](Classes/classllarp_1_1vpn_1_1NetworkInterface.md) > netif, std::shared_ptr< [EventLoopWakeup](Classes/classllarp_1_1EventLoopWakeup.md) > wakeup_recv)<br>attach to a vpn interface.  |
| void | **[attach](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO__Base.md#function-attach)**(std::shared_ptr< [quic::TunnelManager](Classes/classllarp_1_1quic_1_1TunnelManager.md) > quic_tun, std::shared_ptr< [EventLoopWakeup](Classes/classllarp_1_1EventLoopWakeup.md) > wakeup_recv)<br>attach to a quic handler.  |
| virtual std::vector< [OSTraffic](Classes/structllarp_1_1layers_1_1platform_1_1OSTraffic.md) > | **[read_platform_traffic](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO__Base.md#function-read-platform-traffic)**()<br>read from the os.  |
| virtual void | **[write_platform_traffic](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO__Base.md#function-write-platform-traffic)**(std::vector< [OSTraffic](Classes/structllarp_1_1layers_1_1platform_1_1OSTraffic.md) > && traff)<br>write traffic to the os.  |
| void | **[detach](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO__Base.md#function-detach)**()<br>stop all future io and detach from event loop.  |

## Protected Functions

|                | Name           |
| -------------- | -------------- |
| virtual void | **[got_ip_packet](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO__Base.md#function-got-ip-packet)**([net::IPPacket](Classes/structllarp_1_1net_1_1IPPacket.md) ) |

## Protected Attributes

|                | Name           |
| -------------- | -------------- |
| std::weak_ptr< [EventLoop](Classes/classllarp_1_1EventLoop.md) > | **[_loop](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO__Base.md#variable--loop)**  |
| std::shared_ptr< [vpn::NetworkInterface](Classes/classllarp_1_1vpn_1_1NetworkInterface.md) > | **[_netif](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO__Base.md#variable--netif)**  |
| std::shared_ptr< [quic::TunnelManager](Classes/classllarp_1_1quic_1_1TunnelManager.md) > | **[_quic](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO__Base.md#variable--quic)**  |

## Public Functions Documentation

### function OSTraffic_IO_Base

```cpp
explicit OSTraffic_IO_Base(
    const EventLoop_ptr & 
)
```


### function ~OSTraffic_IO_Base

```cpp
virtual ~OSTraffic_IO_Base() =default
```


### function our_platform_addr

```cpp
inline constexpr const PlatformAddr & our_platform_addr() const
```

get the platform address of the underlying device managed. 

### function attach

```cpp
void attach(
    std::shared_ptr< vpn::NetworkInterface > netif,
    std::shared_ptr< EventLoopWakeup > wakeup_recv
)
```

attach to a vpn interface. 

sets up io handlers. idempotently wakes up wakeup_recv when we get packets read. 


### function attach

```cpp
void attach(
    std::shared_ptr< quic::TunnelManager > quic_tun,
    std::shared_ptr< EventLoopWakeup > wakeup_recv
)
```

attach to a quic handler. 

idempotently wakes up wakeup_recv when we get any kind of data from quic_tun. 


### function read_platform_traffic

```cpp
virtual std::vector< OSTraffic > read_platform_traffic()
```

read from the os. 

**Reimplemented by**: [llarp::apple::AppleOSTraffic_IO::read_platform_traffic](Classes/classllarp_1_1apple_1_1AppleOSTraffic__IO.md#function-read-platform-traffic)


this MUST NOT have any internal userland buffering from previous calls to [read_platform_traffic()](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO__Base.md#function-read-platform-traffic). 


### function write_platform_traffic

```cpp
virtual void write_platform_traffic(
    std::vector< OSTraffic > && traff
)
```

write traffic to the os. 

### function detach

```cpp
void detach()
```

stop all future io and detach from event loop. 

## Protected Functions Documentation

### function got_ip_packet

```cpp
virtual void got_ip_packet(
    net::IPPacket 
)
```


## Protected Attributes Documentation

### variable _loop

```cpp
std::weak_ptr< EventLoop > _loop;
```


### variable _netif

```cpp
std::shared_ptr< vpn::NetworkInterface > _netif;
```


### variable _quic

```cpp
std::shared_ptr< quic::TunnelManager > _quic;
```


-------------------------------

Updated on 2023-03-25 at 01:02:44 +0000