---
title: llarp::layers::flow::FlowInfo
summary: in lokinet our onion routed flows are comprised of a source and destination flow layer address, a flow tag (an identifier to mark a distinct flow), and a pivot that each is using in common which acts as our analog to an ipv6 flow label, see rfc6437. 

---

# llarp::layers::flow::FlowInfo



in lokinet our onion routed flows are comprised of a source and destination flow layer address, a flow tag (an identifier to mark a distinct flow), and a pivot that each is using in common which acts as our analog to an ipv6 flow label, see rfc6437. 


`#include <flow_info.hpp>`

## Public Functions

|                | Name           |
| -------------- | -------------- |
| std::string | **[ToString](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md#function-tostring)**() const |
| bool | **[operator==](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md#function-operator==)**(const [FlowInfo](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md) & other) const |

## Public Attributes

|                | Name           |
| -------------- | -------------- |
| [FlowAddr](Classes/classllarp_1_1layers_1_1flow_1_1FlowAddr.md) | **[src](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md#variable-src)** <br>source and destination addresses we associate with this flow.  |
| [FlowAddr](Classes/classllarp_1_1layers_1_1flow_1_1FlowAddr.md) | **[dst](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md#variable-dst)**  |
| [FlowAddr](Classes/classllarp_1_1layers_1_1flow_1_1FlowAddr.md) | **[pivot](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md#variable-pivot)** <br>flow address of the pivot we use to get from src to dst.  |
| [FlowTag](Classes/structllarp_1_1layers_1_1flow_1_1FlowTag.md) | **[tag](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md#variable-tag)** <br>cleartext identifier used on outer framing of the traffic. lets us tell what is from who.  |
| uint16_t | **[mtu](Classes/structllarp_1_1layers_1_1flow_1_1FlowInfo.md#variable-mtu)** <br>mtu between src and dst.  |

## Public Functions Documentation

### function ToString

```cpp
std::string ToString() const
```


### function operator==

```cpp
bool operator==(
    const FlowInfo & other
) const
```


## Public Attributes Documentation

### variable src

```cpp
FlowAddr src;
```

source and destination addresses we associate with this flow. 

### variable dst

```cpp
FlowAddr dst;
```


### variable pivot

```cpp
FlowAddr pivot;
```

flow address of the pivot we use to get from src to dst. 

for .loki traffic this is a .snode address, which we aligh our paths to. for .snode traffic this is a .snode address, which we align our paths to. for .exit traffic this is a .loki address, which we will fetch the exit descriptor it is associated with. 


### variable tag

```cpp
FlowTag tag;
```

cleartext identifier used on outer framing of the traffic. lets us tell what is from who. 

### variable mtu

```cpp
uint16_t mtu {default_flow_mtu};
```

mtu between src and dst. 

-------------------------------

Updated on 2023-03-25 at 01:02:44 +0000